
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	Main Segment

	V1.0 BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Include file declarations

#include "xvis.h"
#include <stdio.h>
#include <unistd.h>
#include <ctype.h>

// ---------------------------------------------
// Global Objects - Working variables

struct objectlist objects[MAXOBJECTS]; 
struct loadref loading_ref[MAXOBJECTS];
struct rgb colour[800];
char *colournamelist[800];
int numcolours=0;
struct editcontrol editor[MAXEDITWINDOWS];
struct modulecontrol module[MAXEDITWINDOWS];
struct filelist cc_files[MAXFILELIST];
struct filelist h_files[MAXFILELIST];
int numccfiles=0;
int numhfiles=0;

int nobject=0;

char *objectName[]= { 	"timer", "list", "button", "repeater", "bitmap", "label", "dropdown",
					"editfield", "box", "toggle", "form", "vscroll", "hscroll", "panner",
					"filelist", "dirlist", "window", "pointer", "none" };

char *className[] = {	"xvTimer", "xvVisualList", "xvButton", "xvRepeater", "xvBitmap",
					"xvLabel", "xvDropDown", "xvEditField", "xvBox", "xvToggle", "xvForm", 
					"xvScrollbar", "xvScrollbar", "xvPanner", "xvFileList", 
					"xvFileList", "xvWindow", "NULL", "NULL" };

Boolean uses3D[] = { FALSE, FALSE, TRUE, TRUE, TRUE, TRUE, FALSE, FALSE, 
				FALSE, TRUE, FALSE, TRUE, TRUE, FALSE, FALSE, FALSE, 
				FALSE, FALSE, FALSE };

objectType objectList[] = {	XVTimer, XVList, XVButton, XVRepeater, XVBitmap, XVLabel, 
						XVDropDown, XVEditField, XVBox, XVToggle, XVForm, XVVScroll,
						XVHScroll, XVPanner, XVFileList, XVDirList, XVWindow, XVPointer, 
						XVNone };

eventType eventList[]={	XVButtonPress, XVButtonRelease, XVEnterNotify, XVLeaveNotify,
					XVFocusIn, XVFocusOut, XVExpose, XVKeyPress, XVKeyRelease,
					XVStructureNotify, XVMap, XVUnmap, XVPointerMotion, 
					XVLeftButtonMotion, XVMidButtonMotion, XVRightButtonMotion };

struct event_data eventinfo[]={	"X_ButtonPress",		1L<<0,	"ButtonPressMask",		"XButtonPressedEvent",
							"X_ButtonRelease",		1L<<1,	"ButtonReleaseMask",	"XButtonReleasedEvent",
							"X_EnterNotify",		1L<<2,	"EnterWindowMask",	"XEnterWindowEvent",
							"X_LeaveNotify",		1L<<3,	"LeaveWindowMask",	"XLeaveWindowEvent",
							"X_FocusIn",			1L<<4,	"FocusChangeMask",	"XFocusInEvent",
							"X_FocusOut",			1L<<5,	"FocusChangeMask",	"XFocusOutEvent",
							"X_Expose",			1L<<6,	"ExposureMask",		"XExposeEvent",
							"X_KeyPress",			1L<<7,	"KeyPressMask", 		"XKeyPressedEvent",
							"X_KeyRelease",		1L<<8, 	"KeyReleaseMask", 	"XKeyReleasedEvent",
							"X_StructureNotify",	1L<<9,	"StructureNotifyMask",	"XConfigureEvent",
							"X_Map",				1L<<10, 	"StructureNotifyMask", 	"XMapEvent",
							"X_Unmap",			1L<<11,	"StructureNotifyMask", 	"XUnmapEvent",
							"X_PointerMotion",		1L<<12,	"PointerMotionMask",	"XPointerMovedEvent",
							"X_Left_Motion", 		1L<<13,	"Button1MotionMask", 	"XPointerMovedEvent",
							"X_Mid_Motion", 		1L<<14,	"Button2MotionMask", 	"XPointerMovedEvent",
							"X_Right_Motion",		1L<<15, 	"Button3MotionMask", 	"XPointerMovedEvent" };

int objectInstance[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

char *listvalues[]={ "Empty List" };

char *wrapinfo[]={ "Never", "Line", "Word" };
char *wrapdata[] = { "XawtextWrapNever", "XawtextWrapLine", "XawtextWrapWord" };

char *scrollinfo[]= {"Never", "WhenNeeded", "Always" };
char *scrolldata[]= { "XawtextScrollNever", "XawtextScrollWhenNeeded", 
							"XawtextScrollAlways"};

char *resizeinfo[] = { "Never", "Width", "Height", "Both" };
char *resizedata[]={ "XawtextResizeNever", "XawtextResizeWidth", 
							"XawtextResizeHeight", "XawtextResizeBoth" };

char *editmodeinfo[] = { "Read/Write", "Read Only", "Append" };
char *editmodedata[] = { "XawtextEdit", "XawtextRead", "XawtextAppend" };

char *buttonshapeinfo[] = { "Rectangle", "Oval", "Ellipse", "Rounded" };
char *buttonshapedata[] = { "XmuShapeRectangle", "XmuShapeOval", "XmuShapeEllipse", 
						"XmuShapeRoundedRectangle" };
int buttonshapecmd[] = { XmuShapeRectangle, XmuShapeOval, XmuShapeEllipse, 
						XmuShapeRoundedRectangle };

char *justifyinfo[] = {"Centre", "Left", "Right"};
char *justifydata[] = {"XtJustifyCenter", "XtJustifyLeft", "XtJustifyRight" };
XtJustify justifycmd[] = { XtJustifyCenter, XtJustifyLeft, XtJustifyRight };

// ---------------------------------------------
// Global Info

Display *working_display;
Screen *working_screen;
int screen_num;
int screenWidth, screenHeight;
Pixel blackPixel, whitePixel;
int screenDepth;
unsigned long screenMask;

// ---------------------------------------------
// Global Class declarations.

xvContext xvisContext;

xvFont cursorfont;
xvMsgBox alert;

xvWindow xvisSelectFile;
	xvFileDialog xvisSelFile;

xvWindow xvisControl;
	xvMenuBar xvisControlMenu;
	xvPulldownMenu xvisFileMenu, xvisObjectMenu, xvisWindowMenu;
	xvPulldownMenu xvisGenerateMenu, xvisHelpMenu;
	xvButton xvisNew, xvisOpen, xvisSave, xvisCC, xvisInfo, xvisNewForm, xvisEditMenu;
	xvLabel xvisCount;
	char countvalue[40];
	char project_name[180];
	char project_path[180];
	int project_list[MAXPROJECTFILES];

xvWindow xvisTools;
	xvLabel toollabel;
	xvToggle xTimer, xBitmap, xDrop, xToggle, xVScroll, xHScroll, xPanner, xList;
	xvToggle xLabel, xEdit, xButton, xRepeater, xBox, xForm, xPointer, xFileList, xDirList;
	
xvWindow xvisProps;
	xvView propview;
	xvForm propform;
	xvList proplist, valuelist;
	xvLabel propobject, proplabel;
	xvButton propchange;
	xvEditField propedit;
	objectType prop_object_type;
	int prop_object_index=-1;
	int selected_index=0;
	char propeditbuffer[120];
	char objname[50];

xvWindow xvisEvents;
	xvToggle eventtoggles[NUMEVENTS];

xvPopupShell xvisColours;
	xvForm colourform;
	xvView colourview;
	xvList colourlist;
	xvLabel colourexample;
	xvButton colourok, colourcancel, colourdefault;
	int colourmode;

xvWindow xvisMake;
	xvEditField maketext;
	xvButton makequit;
	char *makebuffer=NULL;

xvPopupShell xvisCursors;
	xvList xvisCursorList;

xvPopupShell xvisPath;
	xvForm xvisPathForm;
	xvLabel xvisPathLabel;
	xvFileList pathlist;
	xvMsgBox pathAlert;
	xvButton pathok, pathcancel;
	char provpath[180];
	char cwd[200];

xvPopupShell xvisFonts;
	xvFontList masterfontlist;
	xvView fontview;
	xvList fontlist;
	xvForm fontform;
	xvLabel fontexample;
	xvFont fontfont;
	xvButton fontok, fontcancel;

xvWindow xvisObjList;
	xvForm objform;
	xvView objview;
	xvList objlist;
	xvButton objok, objcancel;
	int num_objects=0;
	int selected_ref=0;
	struct object_listdata objectinfo[MAXOBJECTS];
	char *objectlist[MAXOBJECTS];

xvWindow xvisGrid;
	xvLabel xlab, ylab;
	xvButton labok, labcancel;
	xvEditField xval, yval;

xvWindow xvisProjList;
	xvView projview;
	xvList projlist;
	xvButton projOpen, projDelete;
	int num_proj=0;
	char *projectlist[MAXPROJECTFILES+MAXEDITWINDOWS];

xvPopupShell xvisCallList;
	xvForm callform;
	xvView callview;
	xvList calllist;
	xvButton callclose;
	int num_calls=0;
	char *calls_list[20];
	
xvWindow xvisMenus;
	xvEditField menuCaption, menuName, menuCallback;
	xvLabel menuCaptionLabel, menuNameLabel, menuCallbackLabel;
	xvView menuView;
	xvList menuList;
	xvButton menuOK, menuCancel;
	xvButton menuAdd, menuAddSep, menuUpdate, menuRemove, menuClear;
	xvButton menuDown, menuUp, menuMain, menuSub;
	xvButton menuFont;
	xvButton menuBack, menuFore;
	xvButton menuEditCallback;
		
xvWindow xvisGenerate;
	xvButton genOK, genCancel;
	xvLabel AppNameLabel, MakeChoiceLabel, MakeFileLabel, LinkChoiceLabel, LibLabel;
	xvToggle MakeYes, MakeNo;
	xvToggle MakeStatic, MakeShared;
	xvEditField AppName, MakeFile, Libs;

xvEditWindow xvisError;
	char errorbuffer[MAXEDITBUFFERSIZE];

xvPopupShell xvisAbout;
	xvForm aboutform;
	xvLabel aboutmap;
	xvLabel aboutlabel;
	xvButton aboutbutton;

xvPopupMenu objectpopup;
xvCore *CurrentClass;
xvSizer *sizer;
Boolean objectpopupopen=FALSE;

// ---------------------------------------------
// Global Vars & data

Boolean xvisExit=FALSE;
Boolean ToolsVisible=FALSE;
Boolean PropsVisible=FALSE;
Boolean MenusVisible=FALSE;
Boolean ColoursVisible=FALSE;
Boolean EventsVisible=FALSE;
Boolean ProjectListVisible=FALSE;
Boolean ErrorsVisible=FALSE;

Boolean establishedFileFlag=FALSE;

objectType CurrentToolType=XVPointer;
char *CurrentToolName;

objectType CurrentObjectType=XVNone, CurrentParentType=XVNone;
int CurrentObject=-1, CurrentParent=-1;
int ObjectBeingSized=-1;
int ObjectBeingSizedParent=-1;
objectType ObjectBeingSizedParentType=XVNone;
xvWindow *CurrentObjectWindow;
char CurrentObjectName[40]=" ";

struct resource_store resource_values[50];
int resource_full=0;
Boolean resvalflag=FALSE;
char* *resvallist;

int CurrentX, CurrentY;
int RelativeX, RelativeY;

int gridX=10, gridY=10;
Boolean snapToGrid=TRUE, showGrid=TRUE;

// ---------------------------------------------
// Callbacks (Global)

extern void func_file_projsave(Widget aw, XtPointer client, XtPointer call);

void ExecExit()
{
	xvisExit=TRUE;
	for (int i=0; i<MAXOBJECTS; i++) 
		if (objects[i].object_type==XVWindow)
			DeleteNamedObject(objects[i].name);
	for (int i=0; i<MAXTOOLS; i++)
		objectInstance[i]=0;

	xvisControl.Close();
	xvisTools.Close();
	xvisProps.Close();
	xvisEvents.Close();
//	xvisMenus.Close();
	exit(0);
}

void exit_yes(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
	func_file_projsave(0, NULL, NULL);
	ExecExit();
}

void exit_no(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
	ExecExit();
}

void func_exit(Widget aw, XtPointer client, XtPointer call)
{
	
	if (! UnsavedData()) {
		ExecExit();
		return;
	}

	alert.init("UNSAVED DATA", xvisControl, 
		"There is unsaved data.\n Do you want to save?",
		XVMSGSIMPLECHOICE, "green",
		exit_yes, exit_no);
	alert.Open();

}

void func_dummy(Widget aw, XtPointer client, XtPointer call)
{
}

void func_timer(XtPointer cdata, XtIntervalId *id)
{
}

extern void func_window_error(Widget aw, XtPointer client, XtPointer call);

// ---------------------------------------------
// Utility routines

char *normalize(char *source)
{
	char temp[200];

	int len=strlen(source);
	int sptr=0, dptr=0;
	char c, *s;

	while (sptr <len) {
		c=tolower(source[sptr]);
		if (! isspace(c))
			temp[dptr++]=c;
		sptr++;
	}
	temp[dptr]='\0';

	if ((s=strstr(temp, "grey")) != NULL) 
		s[2]='a';


	return temp;
}

Boolean alreadyExist(char *name)
{
	for (int i=0; i<numcolours; i++)
		if (strcmp(name, colour[i].name)==0) 
			return TRUE;
	return FALSE;	
}

// ---------------------------------------------
// Main Stuff

void initialize()
{
	for (int i=0; i<MAXOBJECTS; i++) {
		objects[i].object_type=XVNone;
		objects[i].object_number=i;
		objects[i].num_children=0;
		objects[i].events=0L;
		strcpy(objects[i].obj_cursor, "(default)");
		objects[i].obj_path[0]='\0';
		objects[i].changed=FALSE;
	}

	for (int i=0; i<MAXPROJECTFILES; i++)
		project_list[i]=-1;
	project_name[0]='\0';
	project_path[0]='\0';
	for (int i=0; i<MAXEDITWINDOWS; i++) {
		module[i].in_use=FALSE;
		editor[i].in_use=FALSE;
		module[i].changed=FALSE;
		module[i].first=TRUE;
	}

	working_display=XOpenDisplay(NULL);
	working_screen=DefaultScreenOfDisplay(working_display);
	screen_num=DefaultScreen(working_display);
	screenWidth=WidthOfScreen(working_screen);
	screenHeight=HeightOfScreen(working_screen);
	screenDepth=DefaultDepthOfScreen(working_screen);
	whitePixel=WhitePixel(working_display, screen_num);
	blackPixel=BlackPixel(working_display, screen_num);
	screenMask=AllPlanes;
	XCloseDisplay(working_display);
	getcwd(cwd, 200);

	FILE *fp;
	int cnt=0;
	char tempbuffer[180];
	char red, green, blue, cname[90], nname[90];

	numcolours=0;
	fp=fopen("/usr/lib/X11/rgb.txt", "r");
	if (fp!=NULL) {
		fgets(tempbuffer, 80, fp);
		while (!feof(fp)) {
			fscanf(fp, "%d %d %d\t\t", &red, &blue, &green);
			fgets(cname, 24, fp);
			int i=strlen(cname);
			if (i>0) cname[i-1]='\0';
			strcpy(nname, normalize(cname));
			if (! alreadyExist(nname)) {
				strcpy(colour[numcolours].name, nname);
				colour[numcolours].red=red;
				colour[numcolours].green=green;
				colour[numcolours].blue=blue;
				colournamelist[numcolours]=colour[numcolours].name;
				numcolours++;
			}
		}
		fclose(fp);
		numcolours--;
	}
}

main(int argc, char **argv)
{
	initialize();

	xvisContext.init("xvis", argc, argv);
	buildControlWindow();
	buildToolsWindow();
	buildMenuWindow();
	SetupPropsWindow(XVNone, listvalues, TRUE);
	buildEventsWindow();
	buildProjectListWindow();
	buildCodeGenWindow();
	buildAboutWindow();
	buildGridWindow();

	xvisError.init(xvisContext, "Errors", XawtextRead, errorbuffer, 600, 200, 
		func_window_error, func_window_error, "Errors");
	xvisError.SetWindowResource(XtNiconPixmap, xvisError.xvEditField::SetPixmapInfo(
		xvis_xpm, NULL));
	xvisError.xvEditField::SetBackground("LemonChiffon");

	xvisControl.Open();
	cursorfont.init(xvisControl, "cursor");
	fontfont.init(xvisControl, "*times-*-r-*-140*");
	buildCursorWindow();
	xvisTools.Open();
	xvisProps.Open();
	xvisEvents.Open();
	propedit.SetSensitive(FALSE);
	propedit.SetBackground("gray50");
	propchange.SetSensitive(FALSE);
	propchange.SetBackground("gray50");

	masterfontlist.init(xvisProps, "*", 1000);
	
	XtAppMainLoop(xvisContext.GetContext());
}